455:分发饼干
This commit is contained in:
parent
1a083e04e8
commit
a0ec2d5380
74
src/main/java/leetcode/editor/cn/AssignCookies.java
Normal file
74
src/main/java/leetcode/editor/cn/AssignCookies.java
Normal file
@ -0,0 +1,74 @@
|
||||
//假设你是一位很棒的家长,想要给你的孩子们一些小饼干。但是,每个孩子最多只能给一块饼干。
|
||||
//
|
||||
// 对每个孩子 i,都有一个胃口值 g[i],这是能让孩子们满足胃口的饼干的最小尺寸;并且每块饼干 j,都有一个尺寸 s[j] 。如果 s[j] >= g[
|
||||
//i],我们可以将这个饼干 j 分配给孩子 i ,这个孩子会得到满足。你的目标是尽可能满足越多数量的孩子,并输出这个最大数值。
|
||||
//
|
||||
//
|
||||
// 示例 1:
|
||||
//
|
||||
//
|
||||
//输入: g = [1,2,3], s = [1,1]
|
||||
//输出: 1
|
||||
//解释:
|
||||
//你有三个孩子和两块小饼干,3个孩子的胃口值分别是:1,2,3。
|
||||
//虽然你有两块小饼干,由于他们的尺寸都是1,你只能让胃口值是1的孩子满足。
|
||||
//所以你应该输出1。
|
||||
//
|
||||
//
|
||||
// 示例 2:
|
||||
//
|
||||
//
|
||||
//输入: g = [1,2], s = [1,2,3]
|
||||
//输出: 2
|
||||
//解释:
|
||||
//你有两个孩子和三块小饼干,2个孩子的胃口值分别是1,2。
|
||||
//你拥有的饼干数量和尺寸都足以让所有孩子满足。
|
||||
//所以你应该输出2.
|
||||
//
|
||||
//
|
||||
//
|
||||
//
|
||||
// 提示:
|
||||
//
|
||||
//
|
||||
// 1 <= g.length <= 3 * 10⁴
|
||||
// 0 <= s.length <= 3 * 10⁴
|
||||
// 1 <= g[i], s[j] <= 2³¹ - 1
|
||||
//
|
||||
// Related Topics 贪心 数组 排序 👍 375 👎 0
|
||||
|
||||
package leetcode.editor.cn;
|
||||
|
||||
import java.util.Arrays;
|
||||
|
||||
//455:分发饼干
|
||||
class AssignCookies {
|
||||
public static void main(String[] args) {
|
||||
//测试代码
|
||||
Solution solution = new AssignCookies().new Solution();
|
||||
}
|
||||
|
||||
//力扣代码
|
||||
//leetcode submit region begin(Prohibit modification and deletion)
|
||||
class Solution {
|
||||
public int findContentChildren(int[] g, int[] s) {
|
||||
Arrays.sort(g);
|
||||
Arrays.sort(s);
|
||||
int count = 0;
|
||||
int gi = 0;
|
||||
int si = 0;
|
||||
while (gi < g.length && si < s.length) {
|
||||
if(s[si]>=g[gi]){
|
||||
count++;
|
||||
si++;
|
||||
gi++;
|
||||
}else{
|
||||
si++;
|
||||
}
|
||||
}
|
||||
return count;
|
||||
}
|
||||
}
|
||||
//leetcode submit region end(Prohibit modification and deletion)
|
||||
|
||||
}
|
@ -0,0 +1,37 @@
|
||||
<p>假设你是一位很棒的家长,想要给你的孩子们一些小饼干。但是,每个孩子最多只能给一块饼干。</p>
|
||||
|
||||
<p>对每个孩子 <code>i</code>,都有一个胃口值 <code>g[i]</code><sub>,</sub>这是能让孩子们满足胃口的饼干的最小尺寸;并且每块饼干 <code>j</code>,都有一个尺寸 <code>s[j]</code><sub> </sub>。如果 <code>s[j] >= g[i]</code>,我们可以将这个饼干 <code>j</code> 分配给孩子 <code>i</code> ,这个孩子会得到满足。你的目标是尽可能满足越多数量的孩子,并输出这个最大数值。</p>
|
||||
|
||||
|
||||
<p><strong>示例 1:</strong></p>
|
||||
|
||||
<pre>
|
||||
<strong>输入:</strong> g = [1,2,3], s = [1,1]
|
||||
<strong>输出:</strong> 1
|
||||
<strong>解释:</strong>
|
||||
你有三个孩子和两块小饼干,3个孩子的胃口值分别是:1,2,3。
|
||||
虽然你有两块小饼干,由于他们的尺寸都是1,你只能让胃口值是1的孩子满足。
|
||||
所以你应该输出1。
|
||||
</pre>
|
||||
|
||||
<p><strong>示例 2:</strong></p>
|
||||
|
||||
<pre>
|
||||
<strong>输入:</strong> g = [1,2], s = [1,2,3]
|
||||
<strong>输出:</strong> 2
|
||||
<strong>解释:</strong>
|
||||
你有两个孩子和三块小饼干,2个孩子的胃口值分别是1,2。
|
||||
你拥有的饼干数量和尺寸都足以让所有孩子满足。
|
||||
所以你应该输出2.
|
||||
</pre>
|
||||
|
||||
<p> </p>
|
||||
|
||||
<p><strong>提示:</strong></p>
|
||||
|
||||
<ul>
|
||||
<li><code>1 <= g.length <= 3 * 10<sup>4</sup></code></li>
|
||||
<li><code>0 <= s.length <= 3 * 10<sup>4</sup></code></li>
|
||||
<li><code>1 <= g[i], s[j] <= 2<sup>31</sup> - 1</code></li>
|
||||
</ul>
|
||||
<div><div>Related Topics</div><div><li>贪心</li><li>数组</li><li>排序</li></div></div><br><div><li>👍 375</li><li>👎 0</li></div>
|
Loading…
Reference in New Issue
Block a user